﻿using Borepin.Model;
using Borepin.Service;
using Prism.Mvvm;
using Prism.Navigation;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Text;
using System.Windows.Input;
using Xamarin.Forms;

namespace Borepin.PageModel
{
    public class MachinesPageModel : BindableBase
    {
        private INavigationService _NavigationService;

        public MachinesPageModel(INavigationService navigationService)
        {
            _NavigationService = navigationService;
            GoToMachineCommand = new Command<object>(GoToMachineCommandExecuted);

            MachineList = new ObservableCollection<Machine>(BFFHService_OLD.GetMachines());
        }

        private ICommand _GoToMachineCommand;
        public ICommand GoToMachineCommand
        {
            get => _GoToMachineCommand;
            set => SetProperty(ref _GoToMachineCommand, value);
        }

        private async void GoToMachineCommandExecuted(object obj)
        {
            _NavigationService.GetNavigationUriPath();

            Machine machine = obj as Machine;

            NavigationParameters navigationParams = new NavigationParameters();
            navigationParams.Add("machineID", machine.ID);

            INavigationResult result = await _NavigationService.NavigateAsync($"MachinePage", navigationParams);
            if (!result.Success)
            {
                System.Diagnostics.Debugger.Break();
            }
        }

        private ObservableCollection<Machine> _MachineList;
        public ObservableCollection<Machine> MachineList
        {
            get => _MachineList;
            set => SetProperty(ref _MachineList, value);
        }
    }
}
