﻿using Borepin.Model;
using System;
using System.Threading.Tasks;
using Xamarin.Essentials;

namespace Borepin.Service.Credentials
{
    public class CredentialsService : ICredentialService
    { 
        public async Task<HostCredentials> GetCredentialsAsync(Uri host)
        {
            string username = await SecureStorage.GetAsync(string.Format("bffh_username_{0}", host.ToString()));
            string password = await SecureStorage.GetAsync(string.Format("bffh_password_{0}", host.ToString()));

            HostCredentials hc = new HostCredentials() { Host = host, Username = username, Password = password };

            return await Task.FromResult(hc);
        }

        public async Task<bool> LogCredentialsAsync(HostCredentials credentials)
        {
            await SecureStorage.SetAsync(string.Format("bffh_username_{0}", credentials.Host.ToString()), credentials.Username);
            await SecureStorage.SetAsync(string.Format("bffh_password_{0}", credentials.Host.ToString()), credentials.Password);

            return await Task.FromResult(true);
        }
    }
}
